# Network setup routine by Ray Haque <ray@oddree.com>
# use IZ2S busybox echo for -ne support
# Should only use busybox to move cursor back up
#  to end of prev line.  
# So it still works ok without busybox installed.
# 
# ANSI colors (darK,Red,Green,Yellow,Blue,Magenta,Cyan,White,Normal)
K="\033[1;30m"
R="\033[1;31m"
G="\033[1;32m"
Y="\033[1;33m"
B="\033[1;34m"
M="\033[1;35m"
C="\033[1;36m"
W="\033[1;37m"
N="\033[0m"

# Assume network is off to start.
NETOFF=1
/mnt/ffs/bin/rightledoff

echo "\033[2J\033[1;1H" > /dev/tty0
echo "" > /dev/tty0
echo "-- NETWORK SETUP --" > /dev/tty0
echo "" > /dev/tty0
echo "Join a wireless network? [y/"$B"n"$N"]" > /dev/tty0
echo "\033[1A\033[31C" > /dev/tty0
read -s -n1 enablenet < /dev/tty0
case "$enablenet" in
    'y' | 'Y')
	echo $G"yes"$N > /dev/tty0
	echo "" > /dev/tty0
	prevssid=$(grep 'ssid="' /mnt/ffs/etc/wpa_supplicant.conf | sed -e 's/.*ssid="/  /' -e 's/"//')
	echo "Configured Access Point(s):" > /dev/tty0
	echo "" > /dev/tty0
	echo $B"$prevssid"$N > /dev/tty0
	echo "" > /dev/tty0
	echo "Use current Wifi settings? ["$B"y"$N"/n]" > /dev/tty0
	echo "\033[1A\033[33C" > /dev/tty0
	read -s -n1 scanfornetwork < /dev/tty0
	case "$scanfornetwork" in
	    'n' | 'N')
		echo $R"no"$N > /dev/tty0
		sleep 1
		clear
		echo "" > /dev/tty0
		# Run rkdavis's AP choosing routine.
		/mnt/ffs/bin/setup-wifi.sh
		# ... then return here
		;;
            *)
		echo $G"yes"$N > /dev/tty0
		;;
	esac
	sleep 1
	# Start the daemon and optain an address.
	echo "" >/dev/tty0
	echo "Starting WPA Supplicant ..." > /dev/tty0
	/mnt/ffs/wpa_supplicant/wpa_supplicant -B -ieth0 -c /mnt/ffs/etc/wpa_supplicant.conf > /dev/tty0 
	sleep 1
	echo "" >/dev/tty0
	echo "Obtaining an IP address ..." > /dev/tty0
	udhcpc -n |tee /tmp/udhcpc.log > /dev/tty0
	OK=`grep "No lease, failing" /tmp/udhcpc.log`
	nolease=$?
	if [ $nolease -eq 0  ] ;  then
	    clear
	    echo "" > /dev/tty0
	    echo "Wifi Error:" > /dev/tty0
	    echo "  "$B"O"$N") Ok (continue)" > /dev/tty0
	    echo "  P) Poweroff" >/dev/tty0
	    echo "  R) Reboot" >/dev/tty0
	    read -s -n1 -t10 reboot < /dev/tty0
	    case "$reboot" in
		'p' | 'P')
		    echo "" > /dev/tty0
		    echo "Powering off " >/dev/tty0
		    poweroff
		    sleep 5
		    ;;
		'r' | 'R')
		    echo "" > /dev/tty0
		    echo "Rebooting " >/dev/tty0
		    reboot
		    sleep 5
		    ;;
		*)
		    echo "" > /dev/tty0
		;;
	    esac
	else
	    # Network is ON
	    NETOFF=0
	    /mnt/ffs/bin/rightledon
	    /mnt/ffs/bin/ntpdate 0.pool.ntp.org
	fi
	########
	;;
    *)
	echo $R"n"$N > /dev/tty0
	echo "" > /dev/tty0
	;;
esac

exit $NETOFF
